;;;-*- Mode: Lisp; Syntax: Common-Lisp; Base: 10; Package: if-form -*-
#|
This code was developed in the joint research project APPLY funded by
the German Ministry of Research and Technology under the project code
ITW9102D5.

Copyright 1994-2010 Fraunhofer ISST

Licensed under the EUPL, Version 1.1 or  as soon they will be approved by the European Commission - subsequent 
versions of the EUPL (the "Licence");

You may not use this work except in compliance with the Licence.
You may obtain a copy of the Licence at:
http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
Unless required by applicable law or agreed to in
writing, software distributed under the Licence is distributed on an "AS IS" basis,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.

See the Licence for the specific language governing permissions and limitations under the Licence.

-----------------------------------------------------------------------------------
TITLE: 
-----------------------------------------------------------------------------------
File:    if-form.em
Version: 2.0 (last modification on Mon Feb 28 15:34:27 1994)
State:   proposed

DESCRIPTION:
DOCUMENTATION:
NOTES:
REQUIRES:
PROBLEMS:
AUTHOR: Dr. Horst Firedrich
CONTACT: horst.friedrich@isst.fhg.de
HISTORY: 
Log for /export/home/saturn/ukriegel/Eu2C/Apply/if-form.em[2.0]:
  text
[1.1] Thu Mar 18 09:00:26 1993 hfried@isst proposed
  [Fri Mar  5 13:04:11 1993] Intention for change:
[1.2] Wed Mar 24 13:48:54 1993 hfried@isst proposed
  [Thu Mar 18 09:12:03 1993] Intention for change:
  + glob anna
[1.3] Thu Mar 25 11:19:58 1993 hfried@isst proposed
  [Wed Mar 24 14:53:53 1993] Intention for change:
  + gen-fun
  new head
[1.4] Tue Apr 13 14:09:40 1993 hfried@isst proposed
  [Thu Mar 25 11:54:19 1993] Intention for change:
[1.5] Mon Apr 19 17:31:44 1993 hfried@isst proposed
  [Tue Apr 13 14:15:50 1993] Intention for change:
  alles anders
[1.6] Thu Jun 17 14:03:28 1993 hfried@isst saved
  [Tue Apr 20 15:54:58 1993] Intention for change:
[1.7] Thu Jun 17 15:04:27 1993 rrosen@isst saved
  [Thu Jun 17 14:04:08 1993] Intention for change:
  in-block unbound
[1.8] Fri Jun 18 09:47:22 1993 hfried@isst proposed
  [Thu Jun 17 15:05:26 1993] Intention for change:
  test
[1.9] Mon Jun 21 11:44:34 1993 hfried@isst proposed
  [Fri Jun 18 13:38:47 1993] Intention for change:
  neues interface
  join ok
[1.10] Fri Jun 25 08:28:41 1993 hfried@isst saved
  [Wed Jun 23 16:44:40 1993] Intention for change:
[1.11] Tue Jun 29 09:03:35 1993 hfried@isst proposed
  [Mon Jun 28 16:01:23 1993] Intention for change:
  null f|hrt zur verdrehung der Tests
[1.12] Thu Aug  5 14:31:40 1993 hfried@isst proposed
  [Tue Aug  3 14:32:26 1993] Intention for change:
  falscher Zeig weggeschnitten
[1.13] Wed Aug 18 11:45:11 1993 hfried@isst published
  [Wed Aug 18 08:06:51 1993] Intention for change:
  Ausschrift
[1.14] Mon Sep 13 13:27:56 1993 hfried@isst saved
  
[1.15] Mon Sep 13 14:56:33 1993 hfried@isst saved
  
[1.16] Mon Sep 13 16:13:43 1993 rrosen@isst proposed
  [Mon Sep 13 14:57:18 1993] Intention for change:
  block-test
  done
[1.17] Tue Oct 19 09:20:25 1993 hfried@isst published
  [Tue Oct 19 08:23:02 1993] Intention for change:
  ausschrift
[1.18] Tue Nov 16 08:59:51 1993 hfried@isst proposed
  [Tue Nov 16 08:55:51 1993] Intention for change:
[1.19] Tue Jan  4 11:43:12 1994 akind@isst saved
  [Mon Dec 13 15:35:49 1993] Intention for change:
  import error
[1.20] Mon Jan 31 09:32:12 1994 akind@isst published
  [Tue Jan 11 09:55:37 1994] Intention for change:
  --- no intent expressed ---
[1.21] Wed Mar  2 08:49:26 1994 wheick@isst proposed
  [Mon Feb 28 15:30:47 1994] Intention for change:
  insert eulisp0,1
  done
[2.0] Wed Mar  2 08:49:26 1994 wheick@isst proposed
  [Mon Feb 28 15:30:47 1994] Intention for change:
  insert eulisp0,1
  done

-----------------------------------------------------------------------------------
|#

#module if-form
(import 
 ((except (format) eulisp1)
  SIMPLE-PROGRAMMING
  LZS 
  MZS 
  context 
  analyse-h ; make-vector and vector-ref
  type-propagation
  progn-context
;  void-context
  vector
  lzs-to-mzs-fun
  debugging
  name-of-fun
;  function-call-context
  (only (append caar assoc cdar caar format error) common-lisp)
  type-inference)
;; typeinfernce

 syntax
 (eulisp1)
 
 export 
 (if-form-a) ; label if-form -> tempvar
)



;      ---------
(defun if-form-a (con form)
;      ---------
  (let* ((t-block (make <block>))
         (e-block (make <block>))
         (test (make <test> :then-block t-block
                     :else-block e-block
                     :then-type-descr-s ()
                     :else-type-descr-s ()))
         (then-block ())
         (else-block ()))

    (l2m-a test (?pred form))
;; test inline-divided !!!
    (let ((then-typedescrs ())
          (else-typedescrs ())
          (type-descr-s ()))
      (if (?divided test)
        (progn (setq then-typedescrs (?then-type-descr-s test))
               (setq else-typedescrs (?else-type-descr-s test))
               (setq type-descr-s 
                     (append then-typedescrs else-typedescrs)))
        (if (?function test)
          (let* ((t-pathes (dynamic typepathes))
                 (act-td (make-actual-type-descr 
                          t-pathes test (?var-descr test) 
                          2 ()))
                 )
;; debug 
;          (common-lisp::format t " td  V O R  dem Inferenzschritt")
;          (ti-write::ti-print act-td)
;; end debug
; make a type - inference
            (setq type-descr-s (inference (?function test) 
                                          act-td))
;; debug
;          (common-lisp::format t " td  N A C H  dem Inferenzschritt")
;          (ti-write::ti-print type-descr-s)
;; end debug 
            (setq then-typedescrs (select-then-type-descr 
                                   (?function test)
                                   type-descr-s))
;; debug
;          (common-lisp::format t " then-typedescrs")
;          (ti-write::ti-print then-typedescrs)
;; end debug
            (setq else-typedescrs (select-else-type-descr 
                                   (?function test) 
                                   type-descr-s))
;; debung 
;          (common-lisp::format t " else-typedescrs")
;          (ti-write::ti-print else-typedescrs)
;;end debung
          ; (propagate-type-descrs typedescrs test)
            (setf (?in-label t-block) test)
            (setf (?in-label e-block) test)
            )
          (let ((t-path (dynamic typepathes)))
            (setq then-typedescrs  t-path)
            (setq else-typedescrs t-path))))
      (setq then-block (if then-typedescrs (?then-block test) ()))
      (setq else-block (if else-typedescrs (?else-block test) ()))
;      ; !!! debug
;      (common-lisp::format t "~% if-form: then ~s else ~s" then-block else-block)
;      ; !!! debug 
      (if (and then-block else-block)
        (let* ((env (dynamic env))
               (closure (dynamic closure))
               (pathes (dynamic pathes))
               (then-pathes (cons-block then-block pathes))
               (else-pathes (cons-block else-block pathes))
               )
; add test to the function 
          (setf (dynamic tests) (cons test (dynamic tests)))
; add the type-descriptors
        (setf (?type-descr test) (general-var-actual-descr 2))
        (setf (?type-descr-s test) type-descr-s)
        (setf (?then-type-descr-s test) then-typedescrs)
        (setf (?else-type-descr-s test) else-typedescrs)
        (if (null (?divided test))
          (progn
; link variables
            (link-var-vec (?var-vec (?var-descr test)) test 2)
; add annotation to the called function
            (setf (?applications (?function test))
                  (cons test (?applications (?function test))))
; test is the result of the last block
            (setf (?result (dynamic block)) test)
            (setf (?block test) (dynamic block)))
          ())
        (let ((new-con (if (or (function-label-p con)
                               (join-label-p con)) con
                           (make <join-label>
                                 :context con
                                 :env-level env
                                 :in-block ())))
              then-result else-result)
          (dynamic-let ((block then-block)
                        (pathes then-pathes)
                        (typepathes then-typedescrs))
                       (setq then-result 
                             (l2m-a new-con 
                                    (if (eq then-block t-block )
                                      (?then form)
                                      (?else form))))
;; !!! result 
;                       (setf (?result (dynamic block))
;                             then-result)
					; *hf* 13.09 
		       (if (?t-path (dynamic block))
			   ()
                         (progn
                           (setf (?t-path (dynamic block))
                                 (dynamic typepathes))
                           (if (label-p new-con)
                             (let ((bl (dynamic block))) 
                               (setf (?env bl) 
                                     (dynamic env))
                               (setf (?in-block new-con)
                                     (cons bl
                                           (?in-block new-con)))
                               (setf (?out-label bl)
                                     new-con)
;                               (if (and (join-label-p new-con)
;                                        (null (eq (?context new-con)
;                                                  (dynamic *void-context*))
                               (setf (?result bl) then-result))
                             () )))
                         ; *hf* 13.09 () )
          )
          (dynamic-setq block else-block)
          (dynamic-let (; (block else-block)
                        (pathes else-pathes)
                        (typepathes else-typedescrs)
                        (env env)
                        (closure closure))
                       (setq else-result 
                             (if (eq else-block e-block)
                               (l2m-a new-con (?else form))
                               (l2m-a new-con (?then form))))
;; !!! result
;                     (setf (?result (dynamic block))
;                             else-result)
					; *hf* 13.09 
		       (if (?t-path (dynamic block))
			   ()
                         (let ((bl (dynamic block)))
                           (setf (?t-path bl)
                                 (dynamic typepathes))
                           (if (label-p new-con)
                             (progn 
                               (setf (?env bl) 
                                     (dynamic env))
                               (setf (?in-block new-con)
                                     (cons bl
                                           (?in-block new-con)))
                               (setf (?out-label bl)
                                     new-con)
                               (setf (?result bl) else-result))
                             ())))
                         ; *hf* 13.09 ())
          )
        (if (eq new-con con) ()
; copy of this code in inline.em
            (let ((nenv (join-variables (?in-block new-con) 
                                          (?env-level new-con)))
                  (ntypepathes (append-tpathes (?in-block new-con)))
                  (nblock (make <block> :in-label new-con))
                  (result (dynamic *void-context*)))
              (setf (?out-block new-con) nblock)
              (if (eq con (dynamic *void-context*)) 
                (kill-results (?in-block new-con))
                (setq result  (join-results (?in-block new-con))))
              ; neuer block env etc. 
              (setf (dynamic env) nenv)
              (setf (dynamic typepathes) ntypepathes)
              (setf (dynamic block) nblock)
            result))
        ))
        (if then-block 
          (if (eq then-block t-block )
            (progn
              (information "ELSE-path removed")
              (l2m-a con (?then form)))
            (progn 
              (information "THEN-path removed")
              (l2m-a con (?else form))))
          (if else-block 
            (if (eq else-block e-block)
              (progn 
                (information "THEN-path removed")
                (l2m-a con (?else form)))
              (progn 
                (information "THEN-path removed")
                (l2m-a con (?then form))))
            (error "empty-test"))))))
)

(defun information (txt)
  (let ((fun (analysed-fun)))
    (format t "~% ---------------- information ----------------------")
    (format t "~% in ~a function ~a: ~a" 
            (funtype-of fun) (name-of fun) txt)
    (format t "~% ---------------------------------------------------~%"))
)

(defun join-variables (blocks env-level)
  (if (null blocks) env-level
      (let ((block (car blocks)))
        (join-variables1 block (?env block) env-level)
        (join-variables (cdr blocks) env-level)))
)

(defun join-variables1 (block block-env env-level)
  (if (eq block-env env-level) ()
      (let* ((var (car (car block-env)))
             (fromvar (cdr (car block-env)))
             (oldvar (assoc var env-level))
             (td (empty-actual-descr 1)))
        (if oldvar
          (let* ((tovar (cdr oldvar))
                 (varvec (make-vector 2))
                 (move (make <move>
                             :arg-num 2
                             :var-descr (make <var-descr>
                                          :var-vec varvec
                                          :constant-counter 0)
                             :block block
                             ::type-descr td))
                 (type-descr-s (make-move-tds (?t-path block)
                                      fromvar move)))
            (setf (?type-descr-s move) type-descr-s)
            (setf (dynamic moves) (cons move (dynamic moves)))
            (setf (?interface block)
                  (cons move
                        (?interface block)))
; fill the var-vec
            (setf (vector-ref varvec 0) tovar)
            (setf (vector-ref varvec 1) fromvar)
; link the variables
            (setf (?link tovar)
                  (cons (cons move 0) (?link tovar)))
            (setf (?link fromvar)
              (cons (cons move 1) (?link fromvar)))
            )
          ())
        (join-variables1 block (cdr block-env) env-level)))
)


          

;(defun join-variables (blocks env-level)
;; the result is the new env
;  (let ((join-vars (join-vars1 blocks env-level env-level)))
;    (if (eq join-vars env-level) env-level
;        (add-interface blocks join-vars env-level))
;    ))
;
;(defun join-vars1 (blocks env-level jvars)
;  (if (null blocks) jvars
;      (let ((benv (?env (car blocks))))
;        (if (eq benv env-level)
;          (join-vars1 (cdr blocks) env-level jvars)
;          (join-vars1 (cdr blocks) env-level
;                      (join-vars2 benv env-level jvars))))))
;
;(defun join-vars2 (benv envl jvars)
;  (if (eq benv envl) jvars
;      (let ((var (caar benv)))
;        (if (member-var var jvars envl) 
;          (join-vars2 (cdr benv) envl jvars)
;          (join-vars2 (cdr benv) envl 
;                      (cons (cons var 
;                                  (make <tempvar>
;                                        :tnr (a-number)))
;                                  jvars))))))
;
;(defun member-var (var jvars envl)
;  (cond ((eq jvars envl) nil)
;        ((eq var (caar jvars)) t)
;        (t (member-var var (cdr jvars) envl))))
;
;(defun add-interface (bls j-vars envl)
;  (if (null bls) j-vars
;      (let ((bl (car bls)))
;        (add-interface1 bl (?env bl) j-vars envl)
;        (add-interface (cdr bls) j-vars envl))))
;
;(defun add-interface1 (bl env-bl jvars envl)
;  (if (eq jvars envl) ()
;      (let* ((nvar (cdar jvars))
;             (ovar (cdr (assoc (caar jvars) env-bl)))
;             (varvec (make-vector 2))
;             (move (make <move>
;                         :arg-num 2
;                         :var-descr (make <var-descr>
;                                          :var-vec varvec
;                                          :constant-counter 0)
;                         :block bl)))
;        (setf (dynamic moves) (cons move (dynamic moves)))
;        (setf (?interface bl)
;              (cons move
;                    (?interface bl)))
;; fill the var-vec
;        (setf (vector-ref varvec 0) nvar)
;        (setf (vector-ref varvec 1) ovar)
;; link the variables
;        (setf (?link nvar)
;              (cons (cons move 0) (?link nvar)))
;        (setf (?link ovar)
;              (cons (cons move 1) (?link ovar)))
;        (add-interface1 bl env-bl (cdr jvars) envl))))
        
(defun append-tpathes (blocks)
  (if (cdr blocks) (append (?t-path (car blocks))
                      (append-tpathes (cdr blocks)))
      (?t-path (car blocks))))

(defun kill-results (bls)
  (cond ((null bls) ())
        (t (setf (?result (car bls)) (dynamic *void-context*))
           (kill-results (cdr bls)))))

(defun join-results (blocks)
(let ((jvar (make <tempvar> :tnr (a-number))))
  (join-results1 jvar blocks)
  jvar))

(defun join-results1 (jvar blocks)
  (if blocks
    (let* ((bl (car blocks))
           (td (empty-actual-descr 1))
           (varvec (make-vector 2))
           (vardescr (make <var-descr>
                           :var-vec varvec
                           :constant-counter 0))
           (move (make <move> :arg-num 2 
                       :var-descr vardescr
                       :block bl
                       :type-descr td))
           (q (?result bl))
           (type-descr-s (make-move-tds (?t-path bl) q move)) )
      (setf (?type-descr-s move) type-descr-s)
      (setf (dynamic moves) (cons move (dynamic moves)))
      (setf (vector-ref varvec 0) jvar)
      (setf (vector-ref varvec 1) q)
      (setf (?result bl) jvar)
      (setf (?interface bl)
            (append-stat (?interface bl) move))
      (setf (?result bl) (dynamic *void-context*))
      ; link the variables
      (setf (?link jvar)
            (cons (cons move 0) (?link jvar)))
      (if (or (local-static-p q)
              (tempvar-p q))
        (setf (?link q)
                  (cons (cons move 1) (?link q)))
        ())
      (join-results1 jvar (cdr blocks)))
    ()))
      
#module-end