;;;-*- Mode: Lisp; Syntax: Common-Lisp; Base: 10; Package: move -*-
#|
This code was developed in the joint research project APPLY funded by
the German Ministry of Research and Technology under the project code
ITW9102D5.

Copyright 1994-2010 Fraunhofer ISST

Licensed under the EUPL, Version 1.1 or  as soon they will be approved by the European Commission - subsequent 
versions of the EUPL (the "Licence");

You may not use this work except in compliance with the Licence.
You may obtain a copy of the Licence at:
http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
Unless required by applicable law or agreed to in
writing, software distributed under the Licence is distributed on an "AS IS" basis,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.

See the Licence for the specific language governing permissions and limitations under the Licence.


-----------------------------------------------------------------------------------
TITLE: 
-----------------------------------------------------------------------------------
File:    move.em
Version: 2.0 (last modification on Wed Mar  2 08:33:35 1994)
State:   proposed

DESCRIPTION:
DOCUMENTATION:
NOTES:
REQUIRES:
PROBLEMS:
AUTHOR: Dr. Horst Firedrich
CONTACT: horst.friedrich@isst.fhg.de
HISTORY: 
Log for /export/home/saturn/ukriegel/Eu2C/Apply/move.em[2.0]:
  text
[1.1] Thu Mar 18 09:01:19 1993 hfried@isst proposed
  [Fri Mar  5 13:04:56 1993] Intention for change:
[1.2] Wed Mar 24 13:49:50 1993 hfried@isst proposed
  [Thu Mar 18 09:13:14 1993] Intention for change:
  + glob anna
[1.3] Thu Mar 25 11:21:02 1993 hfried@isst proposed
  [Wed Mar 24 14:55:01 1993] Intention for change:
  + gen-fun
  new head
[1.4] Tue Apr 13 14:10:33 1993 hfried@isst proposed
  [Thu Mar 25 11:54:52 1993] Intention for change:
[1.5] Thu May 27 11:53:29 1993 hfried@isst saved
  [Tue Apr 13 14:16:32 1993] Intention for change:
  type-descr-s
[1.6] Thu May 27 13:41:49 1993 akind@isst proposed
  [Thu May 27 11:57:08 1993] Intention for change:
[1.7] Wed Aug 18 11:45:34 1993 hfried@isst published
  [Tue Aug 10 08:59:32 1993] Intention for change:
  typen behandeln
[1.8] Wed Mar  2 08:34:59 1994 wheick@isst proposed
  [Mon Feb 28 16:02:04 1994] Intention for change:
  insert eulisp0,1
  done
[2.0] Wed Mar  2 08:34:59 1994 wheick@isst proposed
  [Mon Feb 28 16:02:04 1994] Intention for change:
  insert eulisp0,1
  done

-----------------------------------------------------------------------------------
|#

#module move
(import 
 (eulisp1 
  context
  LZS
  analyse-h
  MZS
  type-propagation
  type-inference
  ) 

 syntax 
 (eulisp1 
  simple-programming)

 export 
 (add-move add-move1  ; con form rgloc wgloc 
           add-env) ; con, form 
 )




(defun add-move (var init type rgloc wgloc)
  (add-env var var)
  (add-move1 var init type rgloc wgloc))

(defun add-move1 (var init type rgloc wgloc)
  (let* ((varvec (make-vector 2))
         (td (empty-actual-descr 1))
         (block (dynamic block))
         (move (make <move> 
                     :arg-num 2
                     :var-descr (make <var-descr>
                                      :var-vec varvec
                                      :constant-counter 0)
                     :read-glocs  rgloc 
                     :write-glocs wgloc
                     :block block
                     :type-descr td
                     ))
         
         (type-descr-s (make-move-tds (dynamic typepathes)
                                      init move)))
    (if type
      (progn (set-descr-type td 0 type)
             (set-descr-type td 1 type)
             (check-result-subtypes type-descr-s td))
      ())
    (setf (?type-descr-s move) type-descr-s)
    (dynamic-setq typepathes type-descr-s)
    (setf (dynamic moves) (cons move (dynamic moves)))
    (setf (vector-ref varvec 0) var)
    (setf (vector-ref varvec 1) init)
    (setf (?body block)
          (append-stat (?body block) move))
    (if (or (local-static-p var)
            (tempvar-p var))
      (setf (?link var)
            (cons (cons move 0) (?link var)))
      ())
    (if (or (local-static-p init)
            (tempvar-p init))
      (setf (?link init)
            (cons (cons move 1) (?link init)))
      ())))

(defun add-env (var init)
  (setf (dynamic env) (cons (cons var init) (dynamic env)))
)

#module-end