;;;-*- Mode: Lisp; Syntax: Common-Lisp; Base: 10; Package: slot-value -*-
#|

This code was developed in the joint research project APPLY funded by
the German Ministry of Research and Technology under the project code
ITW9102D5.

Copyright 1994-2010 Fraunhofer ISST

Licensed under the EUPL, Version 1.1 or  as soon they will be approved by the European Commission - subsequent 
versions of the EUPL (the "Licence");

You may not use this work except in compliance with the Licence.
You may obtain a copy of the Licence at:
http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
Unless required by applicable law or agreed to in
writing, software distributed under the Licence is distributed on an "AS IS" basis,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.

See the Licence for the specific language governing permissions and limitations under the Licence.


-----------------------------------------------------------------------------------
TITLE: 
-----------------------------------------------------------------------------------
File:    slot-value.em
Version: 2.0 (last modification on Mon Jan 24 14:40:51 1994)
State:   proposed

DESCRIPTION:
DOCUMENTATION:
NOTES:
REQUIRES:
PROBLEMS:
AUTHOR: Dr. Horst Firedrich
CONTACT: horst.friedrich@isst.fhg.de
HISTORY: 
Log for /export/home/saturn/ukriegel/Eu2C/Apply/slot-value.em[2.0]:
  
[1.1] Mon Jan 24 13:47:10 1994 akind@isst saved
  [Thu Jan 20 14:56:05 1994] Intention for change:
  --- no intent expressed ---
[1.2] Mon Jan 24 15:17:45 1994 hfried@isst saved
  [Mon Jan 24 14:37:21 1994] Intention for change:
  collect all slot-accesses
[1.3] Mon Jan 31 09:33:49 1994 akind@isst published
  [Tue Jan 25 14:39:20 1994] Intention for change:
  --- no intent expressed ---
[2.0] Mon Jan 31 09:33:49 1994 akind@isst proposed
  [Tue Jan 25 14:39:20 1994] Intention for change:
  --- no intent expressed ---


-----------------------------------------------------------------------------------
|#

#module-name slot-value
#module-import 
( level-1-eulisp 
  context
  LZS
  analyse-h
  MZS
  type-propagation
  type-inference
) 


#module-syntax-import (level-1-eulisp simple-programming  )
#module-syntax-definitions

;--- defmacro forms

#module-header-end

;--- exports

;       ##################
(export get-slot-value-a  ; con form 
;       #################
        set-slot-value-a) ; con form 
;       #########


(defun get-slot-value-a (con form)
  (let* ((from (l2m-a (dynamic *arg-context*)
		      (?instance form)))
	 (res (make <tempvar> :tnr (a-number)))
	 (varvec (make-vector 2))
	 (td (empty-actual-descr 1))
	 (block (dynamic block))
	 (var-descr (make <var-descr> :var-vec varvec
			  :constant-counter 0))
	 (type-descr-s (inference-get-slot-value
			(get-slot-tds (dynamic typepathes) 
				      from form)
			(?slot form))))
    (dynamic-setq typepathes type-descr-s)
    (setf (vector-ref varvec 1) from)
    (setf (vector-ref varvec 0) res)
    (setf (?var-descr form) var-descr) ; *hf* 21.01
    (setf (?type-descr form) td)
    (setf (?type-descr-s form) type-descr-s)
    (setf (?arg-num form) 1)
    (setf (?block form) block)
    (setf (dynamic get-slot-value) (cons form (dynamic get-slot-value)))
    (setf (?body block)
	  (append-stat (?body block) form))
    ; variablen linken 
    (setf (?link res)
	  (cons (cons form 0) ()))
    (if (or (local-static-p from)
            (tempvar-p from))
      (setf (?link from)
            (cons (cons form 1) (?link from)))
      ())
    res))

(defun set-slot-value-a (con form)
  (let* ((init (l2m-a (dynamic *arg-context*)
		      (?value form)))
	 (from (l2m-a (dynamic *arg-context*)
		      (?instance form)))
	 (res (make <tempvar> :tnr (a-number)))
	 (varvec (make-vector 3))
	 (td (empty-actual-descr 2))
	 (block (dynamic block))
	 (var-descr (make <var-descr> :var-vec varvec
			  :constant-counter 0))
	 (type-descr-s (inference-set-slot-value
			(set-slot-tds (dynamic typepathes) 
				      from init form)
			(?slot form))))
    (dynamic-setq typepathes type-descr-s)
    (setf (vector-ref varvec 2) init)
    (setf (vector-ref varvec 1) from)
    (setf (vector-ref varvec 0) res)
    (setf (?var-descr form) var-descr) ; *hf* 21.01
    (setf (?type-descr form) td)
    (setf (?type-descr-s form) type-descr-s)
    (setf (?arg-num form) 2)
    (setf (?block form) block)
    (setf (dynamic set-slot-value) (cons form (dynamic set-slot-value)))
    (setf (?body block)
	  (append-stat (?body block) form))
    ; variablen linken 
    (setf (?link res)
	  (cons (cons form 0) ()))
    (if (or (local-static-p from)
            (tempvar-p from))
      (setf (?link from)
            (cons (cons form 1) (?link from)))
      ())
    (if (or (local-static-p init)
	    (tempvar-p init))
	(setf (?link init) 
	      (cons (cons form 2) (?link init)))
      ())
    res))


#module-end