;;;-*- Mode: Lisp; Syntax: Common-Lisp; Base: 10; Package: collection075 -*-
#|

This code was developed in the joint research project APPLY funded by
the German Ministry of Research and Technology under the project code
ITW9102D5.

Copyright 1994-2010 Fraunhofer ISST

Licensed under the EUPL, Version 1.1 or  as soon they will be approved by the European Commission - subsequent 
versions of the EUPL (the "Licence");

You may not use this work except in compliance with the Licence.
You may obtain a copy of the Licence at:
http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
Unless required by applicable law or agreed to in
writing, software distributed under the Licence is distributed on an "AS IS" basis,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.

See the Licence for the specific language governing permissions and limitations under the Licence.
-----------------------------------------------------------------------------------
TITLE: EL-in-CL: standard module collection075
-----------------------------------------------------------------------------------
File:    collection075.em
Version: 1.3 (last modification on Thu Apr 15 11:27:03 1993)
State:   published

DESCRIPTION:

DOCUMENTATION:

NOTES:

REQUIRES:

PROBLEMS:

AUTHOR:
Ingo Mohr

CONTACT: 

HISTORY: 
Log for /export/home/saturn/imohr/Lisp/EulispModules/collection.em[1.0]
	Fri Mar  5 15:39:59 1993 imohr@isst proposed $
 
collection.em[1.1] Wed Mar 10 13:11:19 1993 imohr@isst proposed $
 [Mon Mar  8 14:34:04 1993] Intention for change:
 Log not inside comments
 - with new file header
 - Log-message inside balanced comment
 
collection.em[1.2] Thu Apr 15 09:40:05 1993 imohr@isst save $
 ok
 
collection.em[1.3] Thu Apr 15 11:27:42 1993 imohr@isst published $
 map for NULL as result class
 

-----------------------------------------------------------------------------------
|#

#module collection075

(import
 (eulisp-kernel
  (only (find type-of) common-lisp)
  (rename ((map cl:map)) common-lisp))
 syntax 
 (eulisp-kernel
  (only (case) common-lisp))

 export 
 (member map)
 )

(make-eulisp-class collection sequence)


(defun member (element collection)
(find element collection))

#+(and :ALLEGRO :FRANZ-INC)
(defun franz-type-of (object)
  (let ((type (type-of object)))
    (case type
      ((cl:cons cl:null) 'cl:list)
      (t type))))

(defun map (function collection)
(cl:map (#-(and :ALLEGRO :FRANZ-INC) type-of 
         #+(and :ALLEGRO :FRANZ-INC) franz-type-of
         collection) 
        function collection))

#module-end
